/* Lcd̏ */

#include "lcdLibPrv.h"
#include "common.h"

/* static֐錾 */
static void Lcd_Command(uint8_t ucCmd, uint8_t ucRS);
static void Lcd_Command2(uint8_t ucCmd, uint8_t ucRS);
static void Lcd_RunEbit(void);
static void Lcd_PortInit(void);

/* rW[ǂݏogpꍇ */
#ifdef CONF_LCD_BUSY_READ
static uint8_t Lcd_WaitReady(uint8_t uOnce);
#endif


/********/
/* J */
/********/
// LCD
void Lcd_Init(void)
{
	/******************/
	/* |[gݒ */
	/******************/
	Lcd_PortInit();


	/**********/
	/*  */
	/**********/

	/* 15msҋ@ */
	wait_ms(15);

	/* 0011R񑗐M */
	/* 5ms̃fBC */

	/* P0011𑗐M */
	Lcd_Command(0x03, DEF_LCD_RS_COMM);
	/* 5msҋ@ */
	wait_ms(5);

	/* Q0011𑗐M */
	Lcd_Command(0x03, DEF_LCD_RS_COMM);
	/* 100usҋ@ */
	wait_us(100);

	/* R0011𑗐M */
	Lcd_Command(0x03, DEF_LCD_RS_COMM);
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);


	/* 4bit[h */
	/* ȍ~̓rW[`FbN\ */
	Lcd_Command(0x02, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 100usҋ@ */
	wait_us(100);
#endif

	/**********************/
	/* gpԂɐݒ */
	/**********************/

	/* 4rbgʐMAf[eB[ 1/16ALN^TCY 5x7ݒ */
	Lcd_Command2(0b00101000, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);
#endif


	/* \OFFAJ[\OFFAuNOFFݒ */
	Lcd_Command2(0b00000100, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);
#endif


	/* ݌㎩J[\EړA\VtgOFF */
	Lcd_Command2(0b00000110, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);
#endif

	/* S\NA */
	Lcd_Clear();


	/* \ON */
	Lcd_On();
}


/* ݏ */
void Lcd_Write(uint8_t *szStr, uint8_t ucLen)
{
	/* w蕶 */
	for(uint8_t i = 0; i < ucLen; i++){
		/* PoCg */
		Lcd_Command2(szStr[i], DEF_LCD_RS_DATA);

#ifdef CONF_LCD_BUSY_READ
		/* ҂ */
		Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
		/* 40usҋ@ */
		wait_us(DEF_LCD_SHORT_WAIT);
#endif
	}
}


/* J[\ʒuړ */
/* w0CfbNXōs */
void Lcd_MoveCur(uint8_t x, uint8_t y)
{
	uint8_t tmp;

	/* ͈̓`FbN */
	if((x < DEF_LCD_MAX_X) && (y < DEF_LCD_MAX_Y)){
		tmp = 0b10000000 + x;

		switch(y){
			case 0:		/* 1s */
				/*  */
				break;

			case 1:		/* 2s */
				tmp += 0b01000000;
				break;

#if CONF_LCD_TYPE == DEF_LCD_TYPE_2004
/* SC2004̏ꍇ̂ */
			case 2:		/* 3s */
				tmp += 20;
				break;

			case 3:		/* 4s */
				tmp += 20;
				tmp += 0b01000000;
				break;
#endif
			default:
				/*  */
				/* ړȂ */
				return;
				break;
		}
		/* J[\ړ */
		Lcd_Command2(tmp, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
		/* ҂ */
		Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
		wait_ms(DEF_LCD_SHORT_WAIT);
#endif
	}
}


/* LCD */
void Lcd_Clear()
{
	/* \NA */
	Lcd_Command2(0b00000001, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 2msҋ@ */
	wait_ms(DEF_LCD_LONG_WAIT);
#endif
}


/* LCD off */
void Lcd_Off()
{
	/* LCD off */
	Lcd_Command2(0b00001000, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);
#endif
}


/* LCD on */
void Lcd_On()
{
	/* LCD on */
	Lcd_Command2(0b00001100, DEF_LCD_RS_COMM);

#ifdef CONF_LCD_BUSY_READ
	/* ҂ */
	Lcd_WaitReady(DEF_LCD_WAIT_READY);
#else
	/* 40usҋ@ */
	wait_us(DEF_LCD_SHORT_WAIT);
#endif
}


/**********/
/* J */
/**********/

/* R}hM */
/* 4bit̂ݑM */
void Lcd_Command(uint8_t ucCmd, uint8_t ucRS)
{
	/* erbgɕ */
	ST_PORT_BITFLD st;
	st.uni.byte = ucCmd;

	/* E|[g0Zbg */
	PIN_LCD_E_PORT = DEF_LCD_E_LOW;

	/* RW|[gɏ݂Zbg */
	PIN_LCD_RW_PORT = DEF_LCD_RW_WRITE;

	/* RS|[gZbg */
	PIN_LCD_RS_PORT = ucRS;

	/* e|[g̏o͂ɐݒ */
	PIN_LCD_DB4_PORT = st.uni.bit.P0;
	PIN_LCD_DB5_PORT = st.uni.bit.P1;
	PIN_LCD_DB6_PORT = st.uni.bit.P2;
	PIN_LCD_DB7_PORT = st.uni.bit.P3;

	/* R}hs */
	Lcd_RunEbit();

	/* e|[gLowɖ߂ */
	PIN_LCD_DB4_PORT = 0;
	PIN_LCD_DB5_PORT = 0;
	PIN_LCD_DB6_PORT = 0;
	PIN_LCD_DB7_PORT = 0;
}


/* R}hM */
/* 8bitMiQ񑗐Mj */
/*iEFCg͎Ԃ킩Ȃ̂ŃRRł͂Ȃj */
void Lcd_Command2(uint8_t ucCmd, uint8_t ucRS)
{
	/* ʃrbgM */
    Lcd_Command((ucCmd >> 4) & 0x0F, ucRS);

	/* ʃrbgM */
    Lcd_Command(ucCmd & 0x0F, ucRS);
}


/* Erbg𑀍 */
void Lcd_RunEbit()
{
	/* E|[gɂPZbg */
	PIN_LCD_E_PORT = DEF_LCD_E_HI;

	/* NOPi200nsx҂j */
	/* ԂȂꍇ͂PNOP */
	asmNOP();

	/* E|[g0Zbg */
	PIN_LCD_E_PORT = DEF_LCD_E_LOW;
}

/* LCDŎgp|[g̐ݒ */
void Lcd_PortInit()
{
	/* |[gLow(0)ɐݒ */
	PIN_LCD_RS_PORT = 0;
	PIN_LCD_RW_PORT = 0;
	PIN_LCD_E_PORT = 0;
	PIN_LCD_DB4_PORT = 0;
	PIN_LCD_DB5_PORT = 0;
	PIN_LCD_DB6_PORT = 0;
	PIN_LCD_DB7_PORT = 0;

	/* |[go͂ɐݒ */
	PIN_LCD_RS_DDR = 1;
	PIN_LCD_RW_DDR = 1;
	PIN_LCD_E_DDR = 1;
	PIN_LCD_DB4_DDR = 1;
	PIN_LCD_DB5_DDR = 1;
	PIN_LCD_DB6_DDR = 1;
	PIN_LCD_DB7_DDR = 1;
}


/*****************************/
/* JiBusyǂݏô݁j*/
/*****************************/

/* rW[ԓǂݏoo[W̏ꍇ */
#ifdef CONF_LCD_BUSY_READ

/* ҂ */
uint8_t Lcd_WaitReady(uint8_t uOnce)
{
	uint8_t ucReady;

	/* E|[g0Zbg */
	PIN_LCD_E_PORT = DEF_LCD_E_LOW;

	/* RW|[gɓǂݏoZbg */
	PIN_LCD_RW_PORT = DEF_LCD_RW_READ;

	/* RS|[gZbg */
	PIN_LCD_RS_PORT = DEF_LCD_RS_COMM;

	/* |[g͂ɐݒ */
	/* ŏɏo͂Lowɐݒ */
	/* i͂ɐ؂ւɃvAbvƂȂ̂hj */
	PIN_LCD_DB4_PORT = 0;
	PIN_LCD_DB5_PORT = 0;
	PIN_LCD_DB6_PORT = 0;
	PIN_LCD_DB7_PORT = 0;

	/* |[g͂ɐݒ */
	PIN_LCD_DB4_DDR = 0;
	PIN_LCD_DB5_DDR = 0;
	PIN_LCD_DB6_DDR = 0;
	PIN_LCD_DB7_DDR = 0;

	do {
		/* Pڂ̓ǂݏo */
		/* E|[gɂPZbg */
		/* E|[gHI̊Ԃ̂ݓǂݏo\ */
		PIN_LCD_E_PORT = DEF_LCD_E_HI;

		/* ҋ@ */
		asmNOP();

		/* ǂݏo1 */
		ucReady = PIN_LCD_DB7_PIN;

		/* E|[g0Zbg */
		PIN_LCD_E_PORT = DEF_LCD_E_LOW;

		/* ҋ@ */
		asmNOP();

		
		/* Qڂ̓ǂݏo */
		/* Qڂ͓ǂݔ΂ */
		Lcd_RunEbit();

		/* PmF̏ꍇ͂Ń[vI */
		if(uOnce == DEF_LCD_WAIT_ONCE){
			break;
		}

	/* ʏ̊mF̏ꍇ̓fBɂȂ܂őҋ@ */
	} while(ucReady == DEF_LCD_BUSY);

	/* |[go͂ɍĐݒ */
	PIN_LCD_DB4_DDR = 1;
	PIN_LCD_DB5_DDR = 1;
	PIN_LCD_DB6_DDR = 1;
	PIN_LCD_DB7_DDR = 1;

	/* RW|[gɏ݂Zbg */
	PIN_LCD_RW_PORT = DEF_LCD_RW_WRITE;

	return ucReady;
}

#endif
